//----------------------------------------------------------------------------------------// 
//GLOBAL VARIABLES
//----------------------------------------------------------------------------------------// 
inlets = 1;
outlets = 5;
var offset = 10;
var suggested_offset = 10;
var noiseFloorThresh = -50;
var suggested_noiseFloorThresh = -50;
var dbamp = -60;
var min_amp = 0;
var max_amp = -120;
var calibration = 0;
//----------------------------------------------------------------------------------------// 
function setDbAmp(amp) {
	dbamp = amp;
	if (calibration == 1)
	{	
		if ((amp > max_amp) && (amp < 0))
		{
			max_amp = amp;
			suggested_offset = -max_amp;
			if (suggested_offset < 0)
			{
				suggested_offset = 0;
			}
			outlet(2, suggested_offset);
		}
		if ((amp < min_amp) && (amp >= -120))
		{
			min_amp = amp;
			suggested_noiseFloorThresh = min_amp + suggested_offset;
			outlet(3, suggested_noiseFloorThresh);
		}
	}
	computeAmplitude();
}
//----------------------------------------------------------------------------------------// 
function setOffset(ofs) {
	offset = ofs;
	computeAmplitude();
}
//----------------------------------------------------------------------------------------// 
function setNoiseFloorThresh(nft) {
	noiseFloorThresh = nft;
	computeAmplitude();
}
//----------------------------------------------------------------------------------------// 
function computeAmplitude() {
	var a1, a2, a3, a4;
	a1 = dbamp + offset;
	if (a1 > 0.)
	{
		a1 = 0;//max value should be 0//
	}
	if (a1 < noiseFloorThresh)
	{
		a1 = noiseFloorThresh;//min value should be noiseFloorThresh//
	}
	a2 = a1 / noiseFloorThresh;
	a3 = 1 - a2;
	a4 = a2 * (-120);
	outlet(0, a3);//outputs amplitude on a logarithmic curve//
	outlet(1, a4);//outputs expanded level in dB
}
//----------------------------------------------------------------------------------------// 
function resetCalibration() {
	offset = 10;
	suggested_offset = 10;
	noiseFloorThresh = -50;
	suggested_noiseFloorThresh = -50;
	min_amp = 0;
	max_amp = -120;
	outlet(2, suggested_offset);
	outlet(3, suggested_noiseFloorThresh);
	outlet(4, 1);//sends to the knobs//
}
//----------------------------------------------------------------------------------------// 
function setCalibration(tog) {
	if ((calibration == 0) && (tog == 1))
	{
		//activate calibration//
		calibration = tog;
		resetCalibration();
	}
	if ((calibration == 1) && (tog == 0))
	{
		//desactivate calibration//
		//sends offset and noiseFloorThresh values and makes updates//
		calibration = tog;
		offset = suggested_offset;
		noiseFloorThresh = suggested_noiseFloorThresh;
		outlet(4, 1);		
	}
}
